#include "targetsys.h"
;file "asmcode68.s"

  section .text
  global asmput8,asmput16,asmput32,asmget8,asmget16,asmget32
  global putmpu,regdata,asmaddr,asmdata

;RPC:		long	regdata
RPC:		equ	regdata
RSR:		equ	regdata+4
RUSP:		equ	regdata+8
RMSP:		equ	regdata+12
RISP:		equ	regdata+16
RVBR:		equ	regdata+20
RCACR:		equ	regdata+24
RCAAR:		equ	regdata+28
RSFC:		equ	regdata+32
RDFC:		equ	regdata+36
RD0:		equ	regdata+40
#if(DEVICE==68030)
SCRP:		equ	regdata+104
SSRP:		equ	regdata+112
STC:		equ	regdata+120
STT0:		equ	regdata+124
STT1:		equ	regdata+128
SMMUSR:		equ	regdata+134
#endif
#if(DEVICE==68040)
SURP:		equ	regdata+104
SSRP:		equ	regdata+112
STC:		equ	regdata+120
SDTT0:		equ	regdata+124
SDTT1:		equ	regdata+128
SITT0:		equ	regdata+132
SITT1:		equ	regdata+136
SMMUSR:		equ	regdata+142
#endif
#if(DEVICE==68040 || COPROCESSOR==TRUE)
FPCR:		equ	regdata+144
FPSR:		equ	regdata+148
FPIAR:		equ	regdata+152
FP0:		equ	regdata+156
#endif

asmput8: 	move.b	asmdata+3,(asmaddr)
		rts

asmput16: 	move.w	asmdata+2,(asmaddr)
		rts

asmput32: 	move.l	asmdata,(asmaddr)
		rts

asmget8: 	clr.l	asmdata
		move.b	(asmaddr),asmdata+3
		bpl.b 	nosi8
		or.l   	#$ffffff00,asmdata
nosi8:		rts

asmget16: 	clr.l	asmdata
		move.w	(asmaddr),asmdata+2
		bpl.b 	nosi16
		or.l   	#$ffff0000,asmdata
nosi16:		rts

asmget32: 	move.l	(asmaddr),asmdata
		rts

putmpu:		
		move.l	(RUSP),a0 ; wrm was "mov.l	([RUSP]),%d0 "
#if(DEVICE>=68010)
		move.l	(RVBR),d1
#endif
#if(DEVICE>=68020)
		move.l	(RISP),d2
		move.l	(RMSP),d3
		move.l	(RCAAR),d4
		move.l	(RCACR),d5
		move.l	(RSFC),d6
		move.l	(RDFC),d7
#endif
		move.l	a0,usp ; wrm was "mov.l	%d0,%usp"
#if(DEVICE>=68010)
		move.l	d1,vbr
#endif
#if(DEVICE>=68020)
		move.l	d2,isp
		move.l	d3,msp
		move.l	d4,caar
		move.l	d5,cacr
		move.l	d6,sfc
		move.l	d7,dfc
#endif
#if(DEVICE==68030)
		lea.l 	(SCRP),a0
		short	$f010
		short	$4c00		#pmovee (a0),crp
		lea.l 	(SSRP),a0
		short	$f010
		short	$4800		#pmovee (a0),srp
		lea.l 	(STC),a0
		short	$f010
		short	$4000		#pmovee (a0),tc
		lea.l 	(STT0),a0
		short	$f010
		short	$0800		#pmovee (a0),tt0
		lea.l 	(STT1),a0
		short	$f010
		short	$0c00		#pmovee (a0),tt1
		lea.l 	(SMMUSR),a0
		short	$f010
		short	$6000		#pmovee (a0),psr
#endif
#if(DEVICE==68040)
					#68040 instructions to effect supervisor
					#programer model support should be
					#inserted here and below !
#endif
#if(DEVICE==68040 || COPROCESSOR==TRUE)
		lea.l 	(FPCR),a0
		short	$f210
		short	$9000 		#fmovee.x (a0),fpcr
		lea.l 	(FPSR),a0
		short	$f210
		short	$8800 		#fmovee.x (a0),fpsr
		lea.l 	(FPIAR),a0
		short	$f210
		short	$8400 		#fmovee.x (a0),fpiar
		lea.l 	(FP0),a0
		short	$f210
		short	$d0ff 		#fmoveem.x (a0),fp0-fp7
#endif
		move.w	#$0024,-(a7)
		move.l	(RPC),-(a7)
		move.l	(RSR),d0
		move.w	d0,-(a7)
		movem.l	(RD0),d0-d7/a0-a6
		rte

