#include "targetsys.h"
;file "asmhandler.s"
  section .text
  global stackptr,handler,asmhandler,regdata,handlerflag

SUSP:		equ	regdata+8
SMSP:		equ	regdata+12
SISP:		equ	regdata+16
SVBR:		equ	regdata+20
SCACR:		equ	regdata+24
SCAAR:		equ	regdata+28
SSFC:		equ	regdata+32
SDFC:		equ	regdata+36
SD0:		equ	regdata+40

#if(DEVICE==68030)
SCRP:		equ	regdata+104
SSRP:		equ	regdata+112
STC:		equ	regdata+120
STT0:		equ	regdata+124
STT1:		equ	regdata+128
SMMUSR:		equ	regdata+134
#endif

#if(DEVICE==68040)
SURP:		equ	regdata+104
SSRP:		equ	regdata+112
STC:		equ	regdata+120
SDTT0:		equ	regdata+124
SDTT1:		equ	regdata+128
SITT0:		equ	regdata+132
SITT1:		equ	regdata+136
SMMUSR:		equ	regdata+142
#endif

#if(DEVICE==68040 || COPROCESSOR==TRUE)
FPCR:		equ	regdata+144
FPSR:		equ	regdata+148
FPIAR:		equ	regdata+152
FP0:		equ	regdata+156
#endif

asmhandler:	
		move.l	a7,stackptr
		movem.l	d0-d7/a0-a7,(SD0) ; wrm was "movm.l	&0xffff,([SD0])"
		move.l	usp,a0  ; wrm was "mov.l	%usp,%d0 "
#if(DEVICE>=68010)
		move.l	vbr,d1
		move.l	sfc,d2
		move.l	dfc,d3
#endif
#if(DEVICE>=68020)
		move.l	isp,d4
		move.l	msp,d5
		move.l	caar,d6
		move.l	cacr,d7
#endif
		move.l	d0,(SUSP)
#if(DEVICE>=68010)
		move.l	d1,(SVBR)
		move.l	d2,(SSFC)
		move.l	d3,(SDFC)
#endif
#if(DEVICE>=68020)
		move.l	d4,(SISP)
		move.l	d5,(SMSP)
		move.l	d6,(SCAAR)
		move.l	d7,(SCACR)
#endif
#if(DEVICE==68030)
		lea	(regdata),a0
		short	$f028
		short	$4e00
		short	$0068		#pmovee crp,(104,a0)
		short	$f028
		short	$4a00
		short 	$0070		#pmovee msrp,(112,a0)
		short	$f028
		short	$4200
		short	$0078		#pmovee mtc,(120,a0)
		short	$f028
		short	$0a00
		short	$007c		#pmovee mtt0,(124,a0)
		short	$f028
		short	$0e00
		short	$0080		#pmovee mtt1,(128,a0)
		short	$f028
		short	$6200
		short	$0086		#pmovee mmusr,(134,a0)
#endif
#if(DEVICE==68040)
		lea	(regdata),a0
					#68040 instructions to effect supervisor
					#programer model support should be
					#inserted here and below !
#endif
#if(DEVICE==68040 || COPROCESSOR==TRUE)
		lea	(regdata),a0
		short	$f228
		short	$b000
		short	$0090 		#fmovee.l fpcr,(#144,a0)
		short	$f228
		short	$a800
		short	$0094 		#fmovee.l fpsr,(#148,a0)
		short	$f228
		short	$a400
		short	$0098 		#fmovee.l fpiar,(#152,a0)
		short	$f228
		short	$f0ff
		short	$009c 		#fmoveem.l fp0-fp7,(#156,a0)
#endif

		jsr	handler
		cmp.b	#$0,handlerflag ; wrm was "cmp.b	handlerflag,&0"
		blt	backtomonitor
		move.l	(SUSP),d0

#if(DEVICE>=68010)
		move.l	(SVBR),d1
		move.l	(SSFC]),d2
		move.l	(SDFC),d3
#endif
#if(DEVICE>=68020)
		move.l	(SISP),d4
		move.l	(SMSP),d5
		move.l	(SCAAR),d6
		move.l	(SCACR),d7
#endif

		move.l	a0,usp ; wrm was "mov.l	%d0,%usp"

#if(DEVICE>=68010)
		move.l	d1,vbr
		move.l	d2,sfc
		move.l	d3,dfc
#endif
#if(DEVICE>=68020)
		move.l	d4,isp
		move.l	d5,msp
		move.l	d6,caar
		move.l	d7,cacr
#endif
		movem.l	(SD0),d0-d7/a0-a7 ; wrm was "movm.l	([SD0]),&0xffff"
#if(DEVICE==68030)
		lea.l 	(SCRP),a0
		short	$f010
		short	$4c00		#pmovee (a0),crp
		lea.l 	(SSRP),a0
		short	$f010
		short	$4800		#pmovee (a0),srp
		lea.l 	(STC),a0
		short	$f010
		short	$4000		#pmovee (a0),tc
		lea.l 	(STT0),a0
		short	$f010
		short	$0800		#pmovee (a0),tt0
		lea.l 	(STT1),a0
		short	$f010
		short	$0c00		#pmovee (a0),tt1
		lea.l 	(SMMUSR),a0
		short	$f010
		short	$6000		#pmovee (a0),psr
#endif
#if(DEVICE==68040)
					#68040 instructions to effect supervisor
					#programer model support should be
					#inserted here !
#endif
#if(DEVICE==68040 || COPROCESSOR==TRUE)
		lea.l 	(FPCR),a0
		short	$f210
		short	$9000 		#fmovee.x (a0),fpcr
		lea.l 	(FPSR),a0
		short	$f210
		short	$8800 		#fmovee.x (a0),fpsr
		lea.l 	(FPIAR),a0
		short	$f210
		short	$8400 		#fmovee.x (a0),fpiar
		lea.l 	(FP0),a0
		short	$f210
		short	$d0ff 		#fmoveem.x (a0),fp0-fp7
#endif
		rte
backtomonitor:	move.w	#$2700,sr
		jmp	abortstart
