
#include "targetsys.h"

#include "userdef.h"

#include "vardef.h"

#include "textdef.h"

/* ***************************************************** */

extern SIZETYPES sizefield[];

/* asmprocport.s */
void put8(int addr, int data);
void put16(int addr, int data);
void put32(int addr, int data);
void prepreg(struct regelem reg[]);
void storereg(struct regelem reg[]);
int get8(int addr);
int get8s(int addr);
int get16(int addr);
int get16s(register int addr);
int get32(register int addr);

/* printport.c */
int print(char *pfmt);


/* main.c */
void mainloop(void);

/*
these are the external declerations for use by main. Any command
added/deleted should be added/deleted from here.
*/


extern int dccmd(),bfcmd(),bmcmd(),brcmd(),bscmd(),hecmd(),locmd();
extern int tmcmd(),rdcmd(),rmcmd(),mmcmd(),mdcmd(),gocmd();
extern int trcmd(), ascmd(),sdcmd();

void insertbr(void);

int whitesp(char ch); /* see if ch is a whitespace character */

/* ***************************************************** */

void shiftarg(char *str, int num); /* shift the string str, num characters to the left */

/* ***************************************************** */

void striparg(char *str); /* strip characters from front of string until nonwhitespace */

/* ***************************************************** */
/*
getnum routine converts an expression into number.
It will continue to add and subtract until it reaches a special charachter or
an error. If an error is found, a global flag, error, is set to TRUE. If no
error is found, then the global flag error is set to FALSE. 
The numbers in the expressiong string are converted according to DEFAULTSCALE,
unless overridden by a delimiter in the string.
*/
/* ***************************************************** */

int getnum(char *str, char err[], int iscale);

/* ***************************************************** */
/* 
getsize returns the byte equivalent from the <size> option.
It returns BYTE for -b, WORD for -w, HALF for -h, LONG for -l and DFSIZE if
no option was expressed.
*/
/* ***************************************************** */

int getsize(char *str, char err[]); /* get option size from command line */

/* ***************************************************** */
/* 
this returns the number of "size" large units in the memory area described
by <range>. If <range> is two addresses, then the memory is divided into
"size" large units. If <range> is a count, then the count is the number
following the COUNTDEL. 
*/
/* ***************************************************** */

int getcount(char *str, int size, int strt, char err[]);


/* ***************************************************** */

void stripwhite(char *str);

/* ***************************************************** */

int check(void);

/* ***************************************************** */
	

int findport(char *str, char *err);

/* ***************************************************** */

#if(DEVICE==68040 || COPROCESSOR==TRUE)

printfpu()
{
extern struct regelem mpu[];
register int i,j;

	for (i = 0;mpu[i].name[0] != 'F' && mpu[i].name[1] != 'P';i++)
		;

	print("\n");
	for (;mpu[i].name != LASTCMD;i++)
	{
		if (mpu[i].name[0] == BREAK)
			print("\n");
		else if (mpu[i].name[2] >= '0' && mpu[i].name[2] <= '7')
		{
			if (mpu[i].name[2] == '0')
				print("\n");
			print(mpu[i].name);
			print("=%c%8x%8x%8x   ",HEXDEL,mpu[i].value,mpu[i+1].value,mpu[i+2].value);
			printFPx(i);
			i++;
			i++;
			j = 0;
			print("\n");
		}
		else
		{
			print(mpu[i].name);
			print("=%c%8x   ",HEXDEL,mpu[i].value);
			j++;
		}
		check();
	}
	print("\n");
}

/* ************************************************************************* */
/* ROUTINE: printFPx							     */
/* ************************************************************************* */

printFPx(mpu_entry)
int mpu_entry;
{

extern struct regelem mpu[];
int f0_fp,f1_fp,f2_fp;

	f0_fp=mpu[mpu_entry].value;
	f1_fp=mpu[mpu_entry+1].value;
	f2_fp=mpu[mpu_entry+2].value;
	print("     ");
	if(bitnum(31,31,f0_fp))
		print("-");
	print("%d_%8x%8x_E%d",bitnum(31,31,f1_fp),(bitnum(30,0,f1_fp)<<1),bitnum(31,0,f2_fp),bitnum(30,16,f0_fp)-16383);
}

#endif

/* ***************************************************** */

void printreg(struct regelem reg[]);


/* **************************************************** */
void findreg(char *strng, struct regelem reg[], int query, char *argv);


/* ****************************************************** */

