/* ***************************************************************** */
/*
This is a file for defining strings used by the monitor. If you want
to change the prompt, an error message, etc. this is the place you
will find it.
Note, if a new string is added, then userdef's extern statement must
be changed for the commands to recognize it.
*/

/* wrm split into textdef.h and textdef.c to prevent multiple definitions */

/* ***************************************************************** */

/* ****************ADDITIONS*********************** */

extern EAFIELD seperatorfield[5];
extern EAFIELD actualfield[5];


#if(COPROCESSOR==TRUE || DEVICE==68040)
extern COPROCCONTROLREG COPROCCRreg[];
extern COPROCCONDITIONALS typepredicate[32];
extern MONADICDYADIC MONAorDYA[];
#endif/* COPROCESSOR==TRUE */

extern CONTROLREG CRreg[];
extern SIZETYPES sizefield[];
extern TYPES typebitfield[8];
extern CONDITIONALS typecondition[16];
extern EAALLOWED_TYPE EAtype[];
extern ACTUALFIELD_T_F Field_option[5];
extern EASPEC EA[2];	/* where SorD will be either TRUE or FALSE and be used to
		   determine which is being used ie. EA[SorD]		*/


/* The DEVICE that the target system uses will determine which OPSTRUCTURE
   will be compiled into the monitor */

/* NOTE: FOR INSTRUCTION ENTRIES OF THE SAME TYPE THE LONGEST SIZE OPTION
	 SHOULD BE ENTERED FIRST!!!!!!!!!!!!!				*/

extern OPSTRUCTURE syntax1[];

#if (COPROCESSOR==TRUE || DEVICE==68040)
extern COPROCSTRUCTURE syntax2[];
#endif

/* ****************ADDITIONS*********************** */

/*
these are the predefined symbols for the symbol table. The correspond
to the standard MOTOROLA memory map. To change the startup symbols,
change them here. To add or delete the startup symbols, add or delete
from here and in doinit under main.c .
*/

extern char ROMSYMB[];

/*
these are the registers known. They are currently set up for a maximum
size of 4 char plus a blank. To add or delete registers known, change
the names here and in doinit under main.c 
*/

extern char d_0[]; // = "D0   ";
extern char d_1[]; // = "D1   ";
extern char d_2[]; // = "D2   ";
extern char d_3[]; // = "D3   ";
extern char d_4[]; // = "D4   ";
extern char d_5[]; // = "D5   ";
extern char d_6[]; // = "D6   ";
extern char d_7[]; // = "D7   ";
extern char a_0[]; // = "A0   ";
extern char a_1[]; // = "A1   ";
extern char a_2[]; // = "A2   ";
extern char a_3[]; // = "A3   ";
extern char a_4[]; // = "A4   ";
extern char a_5[]; // = "A5   ";
extern char a_6[]; // = "A6   ";
extern char a_7[]; // = "A7   ";
extern char p_c[]; // = "PC   ";
extern char s_r[]; // = "SR   ";
extern char usp[]; // = "USP  ";
extern char msp[]; // = "MSP  ";
#if(DEVICE<68020)
extern char ssp[]; // = "SSP  ";
#else
extern char isp[]; // = "ISP  ";
#endif
extern char sfc[]; // = "SFC  ";
extern char dfc[]; // = "DFC  ";
extern char vbr[]; // = "VBR  ";
extern char cac[]; // = "CACR ";
extern char caa[]; // = "CAAR ";
#if(DEVICE==68030)
extern char crp[]; // = "CRP  ";
extern char srp[]; // = "SRP  ";
extern char tc[]; //  = "TC   ";
extern char tt_0[]; // = "TT0  ";
extern char tt_1[]; // = "TT1  ";
extern char mmusr[]; // = "PSR  ";
#endif
#if(DEVICE==68040)
extern char urp[]; // = "URP  ";
extern char srp[]; // = "SRP  ";
extern char tc[]; //  = "TC   ";
extern char dtt_0[]; // = "DTT0 ";
extern char dtt_1[]; // = "DTT1 ";
extern char itt_0[]; // = "ITT0 ";
extern char itt_1[]; // = "ITT1 ";
extern char mmusr[]; // = "PSR  ";
#endif

/*
these are the miscellanous messages that are needed in different parts
of the program.
*/

extern char PROMPT[]; // = "\nMOTOROLA> ";
extern char WHICHREGMSG[]; // = "Which register? ";
extern char BRKMSG[]; // = "Break Point:\n";
extern char SYMBMSG[]; // = "Known Symbols:\n";
extern char UNKNOWNMSG[]; // = "UNKNOWN\t\t\t?";
extern char HITKEYMSG[]; // = "Hit any key to continue ...\n";
extern char MMASHELPMSG[]; // = "\nDirectives.\nBackup -[<number>], Advance +[<number>], Help '?', Quit 'q' or '.'\n\n";

/*
hese are the error messages that are printed out at different
procedures thoughout the program.
*/

extern char NOERR[]; // = "";
extern char ERR01[]; // = "ERROR 01: illegal number of arguments\n";
extern char ERR02[]; // = "ERROR 02: illegal address syntax\n";
extern char ERR03[]; // = "ERROR 03: illegal number syntax\n";
extern char ERR04[]; // = "ERROR 04: illegal option\n";
extern char ERR05[]; // = "ERROR 05: insufficient room to insert data\n";
extern char ERR06[]; // = "ERROR 06: breakpoint table is full\n";
extern char ERR07[]; // = "ERROR 07: illegal command call\n";
extern char ERR08[]; // = "\nERROR 08: S-record load failed, invalid checksum = ";
extern char ERR09[]; // = "ERROR 09: invalid assembly => ";

/*
this is a list of the various syntaxes for the commands. It is
accessed under he command, by typing he and then the syntax name.
*/

extern struct syntax_element syn[];

/*
these are the ports known by the monitor. To add ports, add them here
*/

extern struct port_element p[];

/*
this is the table of commands known, the pointer to the procedure that
handles the command and the syntax for each command. To add or delete
new commands, do so here. Alphabetical order is suggested, but not
required.
*/

extern struct table_element f[];

/*
this is a table used for determining the m5 field for bcnd and tcnd
instructions. It is used in disasm88 and can be commented out if the
assembler/disassembler is a 68000 family one.
*/

extern char *equality[];




/* ***************************************************************** */
